"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GAException(ProtocolElement):
    """
    A general exception type.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "message",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import ga4gh as ga4gh_3_0_0

        return {
            "org.ga4gh.methods.GAException": ga4gh_3_0_0.GAException,
        }

    __slots__ = [
        "message",
        "errorCode",
    ]

    def __init__(
        self,
        message,
        errorCode=-1,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_0_0.GAException model.

        :param message:
            The error message
        :type message: str
        :param errorCode:
            The numerical error code
        :type errorCode: int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
